//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37FDFEAE0E48.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37FDFEAE0E48.cm

//## begin module%37FDFEAE0E48.cp preserve=no
//## end module%37FDFEAE0E48.cp

//## Module: DummyResponse%37FDFEAE0E48; Package body
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Data/Detector/DummyResponse.cxx

//## begin module%37FDFEAE0E48.additionalIncludes preserve=no
//## end module%37FDFEAE0E48.additionalIncludes

//## begin module%37FDFEAE0E48.includes preserve=yes
#include <sstream>
#include <limits>
#include <iostream>
#include <iomanip>
//## end module%37FDFEAE0E48.includes

// SumComponent
#include <XSModel/Model/Component/SumComponent.h>
// DummyResponse
#include <XSModel/Data/Detector/DummyResponse.h>
//## begin module%37FDFEAE0E48.declarations preserve=no
//## end module%37FDFEAE0E48.declarations

//## begin module%37FDFEAE0E48.additionalDeclarations preserve=yes
#include "XSsymbol.h"
// This is the name that will be the key for the DummyResponse when
// it is inserted into the global response container.
const std::string DUMMY_RSP("$#aw46gXS_DUMMY");
//## end module%37FDFEAE0E48.additionalDeclarations


// Class DummyResponse 

//## begin DummyResponse::instance%37FB7D2E59C0.attr preserve=no  private: static DummyResponse* {U} 0
DummyResponse* DummyResponse::s_instance = 0;
//## end DummyResponse::instance%37FB7D2E59C0.attr

DummyResponse::DummyResponse (Real eMin, Real eMax, size_t nE, bool ln)
  //## begin DummyResponse::DummyResponse%37FD0E98F4C0.hasinit preserve=yes
  //: Response(), m_energyArray(nE+1,0.), 
      : UserDummyResponse()
        
  //## end DummyResponse::DummyResponse%37FD0E98F4C0.hasinit
  //## begin DummyResponse::DummyResponse%37FD0E98F4C0.initialization preserve=yes
  //## end DummyResponse::DummyResponse%37FD0E98F4C0.initialization
{
  //## begin DummyResponse::DummyResponse%37FD0E98F4C0.body preserve=yes
                
//        IntegerArray id(nE,1);
//        setBinResponseGroups(id);
//        MatrixIndex  im(nE,0);
//        for (int i = 0; i < nE; ++i) im[i].push_back(i);
        
//        setBinRunLengths(im);
//        setBinStartChannels(im);
        isLog(ln);
        
        // set the active flag to false. This is used to tell the model that
        // the response is the default dummy response which cannot be used for
        // fitting data. 
        //  
        setActive(false);
        std::numeric_limits<Real> RealInfo;
        eMin  = std::max(eMin,RealInfo.min());
	
	if (eMax <= eMin || nE == 0)
	{
	   std::ostringstream errMsg;
	   errMsg << "\nError in user-defined dummy response specification."
	      << "\nNo. Energies: " << nE << "\n Low Energy: " << eMin 
	      << "\n High Energy: " << eMax << 
	      "\n...using predefined values, N=40, min=0.5, max=20 keV"<<std::endl;
	   nE = 40;
	   eMin = .5;
	   eMax = 20.0;
	}
	numEnergies(nE);
        numChannels(nE);	
	eLow(eMin);
	eHigh(eMax);
        setEnergies();
        channels(energies());
        generateResponse();
  //## end DummyResponse::DummyResponse%37FD0E98F4C0.body
}


DummyResponse::~DummyResponse()
{
  //## begin DummyResponse::~DummyResponse%3641DA6E0109_dest.body preserve=yes
  //## end DummyResponse::~DummyResponse%3641DA6E0109_dest.body
}



//## Other Operations (implementation)
DummyResponse* DummyResponse::Instance (Real eMin, Real eMax, size_t nE, bool ln)
{
  if (s_instance == 0) {s_instance = new DummyResponse(eMin,eMax,nE,ln);} return s_instance;


  //## begin DummyResponse::Instance%37FB7D2EC2C0.body preserve=yes
  //## end DummyResponse::Instance%37FB7D2EC2C0.body
}

void DummyResponse::resetEnergies (Real eMin, Real eMax, size_t nE, bool ln)
{
  //## begin DummyResponse::resetEnergies%37FD1085B6D8.body preserve=yes
  // This assumes input parameters have been validate before they get here.
        isLog(ln);
        numEnergies(nE);
        numChannels(nE);
	eLow(eMin);
	eHigh(eMax);
	setEnergies();
        channels(energies());
        generateResponse();
  //## end DummyResponse::resetEnergies%37FD1085B6D8.body
}

Model& DummyResponse::operator * (Model& model) const
{
  //## begin DummyResponse::operator*%37FE0B5509B8.body preserve=yes
  // this, the "folding operator" for dummy responses, simply returns
  // its argument. 
  return model; 
  //## end DummyResponse::operator*%37FE0B5509B8.body
}

void DummyResponse::source (SpectralData* value)
{
  // never to be called.

  //## begin DummyResponse::source%3AAF86230150.body preserve=yes
  //## end DummyResponse::source%3AAF86230150.body
}

SpectralData* DummyResponse::source () const
{
  //## begin DummyResponse::source%3AC2299D03B4.body preserve=yes
  //## end DummyResponse::source%3AC2299D03B4.body

  return 0;
}

void DummyResponse::operator * (SumComponent& source) const
{
  //## begin DummyResponse::operator*%3DE7D2E002D9.body preserve=yes
  int iData(spectrumNumber());
  // one of those rare uses for const_cast which seem to be acceptable.
  // source is cast to const so it can call the const versions of
  // photonArray(), etc ... the non-const versions are protected.
  const SumComponent& csource = const_cast<SumComponent&>(source);
  source.foldedPhotonFlux(iData).resize(csource.photonArray(iData).size());
  source.foldedPhotonFluxErr(iData).resize(csource.photonErrArray(iData).size());
  source.foldedPhotonFlux(iData) = csource.photonArray(iData);
  source.foldedPhotonFluxErr(iData) = csource.photonErrArray(iData);
  //## end DummyResponse::operator*%3DE7D2E002D9.body
}

void DummyResponse::generateResponse ()
{
  //## begin DummyResponse::generateResponse%3ED4D2070311.body preserve=yes
  MatrixValue& diagMatrix = matrix();
  std::vector<std::size_t>& startEngs = dmyStartEngs();
  size_t nC = numChannels();
  diagMatrix.resize(nC);
  startEngs.resize(nC);
  for (size_t i=0; i<nC; ++i)
  {
     startEngs[i] = i;
     diagMatrix[i].resize(1, 1.0);
  }
  //## end DummyResponse::generateResponse%3ED4D2070311.body
}

// Additional Declarations
  //## begin DummyResponse%3641DA6E0109.declarations preserve=yes
  //## end DummyResponse%3641DA6E0109.declarations

//## begin module%37FDFEAE0E48.epilog preserve=yes
//## end module%37FDFEAE0E48.epilog
